#ifndef _RLS_PRESDS_
#define _RLS_PRESDS_

#include "presenceagent.h"

#include <string>
#include <map>

using namespace std;

/**
 * RLSPresentityDS - RLSPresentity Data API's.
 * To create, store, retrieve and delete RLS's presentity
 * It has mapping table between incoming call and outgoing call 
 *   so that it can send NOTIFY to the proper subscriber.
 */
class RLSPresentityDS {
  
  private :	
  MySIP_PA* incomingCall;
  MySIP_PA* outgoingCall;
  
  string presentity_name;
  string presentity_domain;
  string uri;

  bool unsubscription; 

 public:
  
  RLSPresentityDS();
  
  //Constructor takes the name of presentity as string "user@domain"
  RLSPresentityDS(string);
  ~RLSPresentityDS();

  
  string getRLSPresentityName(){ return presentity_name; }
  void setRLSPresentityName(string name) { presentity_name = name; }
  
  string getDomain(){ return presentity_domain; }
  void setDomain(string dom){ presentity_domain = dom; }	  
  
  string getURI(){ return presentity_name; }
  void setURI(string u){ uri = u; }

  

  inline void setIncomingCall(MySIP_PA* call) { incomingCall = call; }
  inline MySIP_PA* getIncomingCall(){ return incomingCall; }

  inline void setOutgoingCall(MySIP_PA* call) { outgoingCall = call; }
  inline MySIP_PA* getOutgoingCall(){ return outgoingCall; }


  bool getUnsubscription(){ return unsubscription; }
  void setUnsubscription(bool _unsubscription) { 
    unsubscription = _unsubscription; 
  }

  /**
   * Store: storing outgoing dialog to the list, 'outgoingCalls'.
   *        so it can have multiplle outgoing calls for the subscriber
   */
  void store(string, MySIP_PA*);

  /**
   * remove: remove all the resources
   */
  void remove();
};
#endif
