#ifndef _SUBSCRIBE_EVENTLIST_HANDLER
#define _SUBSCRIBE_EVENTLIST_HANDLER


#include "subscribe_pres_handler.h"
#include "sipmessage.h"

#include <vector>

/**
 * SubscribeEventlistHandler
 * Validates, Authorizes and Creates Subscription
 * Generates a Notification with the appropriate state
 */
class SubscribeEventlistHandler : public  SubscribePresHandler
{
  public :
    /**
     * Provide Multiple constructors
     *
     */
    SubscribeEventlistHandler();
  ~SubscribeEventlistHandler();
  SubscribeEventlistHandler(void *mySIP_pa);
  SubscribeEventlistHandler(const SIPRequestMessage &);
  SubscribeEventlistHandler(const SIPRequestMessage &, void *mySIP_pa);
  
  /**
   * Creates a Subscription.
   * In memory and in Database(if new subscription)
   * -> returns -1 if failed in creating subscription or error
   */
  virtual int createSubscription(const SIPRequestMessage &, string);
  virtual int createSubscriptionDB(const SIPRequestMessage &, string);

  /**
   * To check the user is in Memory 
   *
   */
  virtual bool checkUserInDB(string);
  virtual PresentityDS* checkUserInMemory(string);
  RLSPresentityDS* checkRLSUserInMemory(string);


  /**
   * To send SUBSCRIBE using the call, MySIP_PA object
   * 
   */
  void SendSubscribe(MySIP_PA*, string, string, string);

  //Internal method. return the resources in the list
  vector<string> getResources(string);

};
#endif
