#ifndef _SUBSCRIBE_PRES_HANDLER
#define _SUBSCRIBE_PRES_HANDLER
#include "subscribe_base_handler.h"
#include "sipmessage.h"
#include "subds.h"
/**
 * SubscribePresHandler
 * Validates, Authorizes and Creates Subscription
 * Generates a Notification with the appropriate state
 */
class SubscribePresHandler : public  SubscribeBaseHandler
{
   public :
	SubscribePresHandler();
	~SubscribePresHandler();
	SubscribePresHandler(void *mySIP_pa);
	SubscribePresHandler(const SIPRequestMessage & request);
	SubscribePresHandler(const SIPRequestMessage & request,void *mySIP_pa);

	/**
	 *-> Validate type of Event Package.
	 *-> Validate value of Expires interval
	 *-> Validate Watcher filter and Store it
	 *-> Sends back appropriate response if failed valiation
	 *-> returns -1 if failed  Validating or error
	 */
	virtual int validateSubscription(const SIPRequestMessage & request);
	
	/**
	 *  Creates subscription entry in Database.
	 */
	virtual int createSubscriptionDB(const SIPRequestMessage & request);
	
	/**
	 * Creates a Subscription.
	 * In memory and in Database(if new subscription)
	 * -> returns -1 if failed in creating subscription or error
	 */
	virtual int createSubscription(const SIPRequestMessage & request);
	
	/**
	 * Presence Authorization.
	 * look up from DB policy and send response(200,2020, 4XX).
	 * Sets the subscription state to be used when sending NOTIFY.
	 *
	 * returns -1 if error. 
	 */
	virtual int authorizeSubscription(const SIPRequestMessage & request);
	
};
#endif
