#include "unsubscription.h"
#include "DataManager.h"
#include "presds.h"

UnSubscription::UnSubscription()
{
}

UnSubscription::UnSubscription(PresenceHandler *ph, string _presentity)
{
  debug(DEBUG_IMPP, "UnSubscription::", "Constructor entered\n");
  pHandler = ph;
  presentity = _presentity;
}


UnSubscription::~UnSubscription()
{
}


int UnSubscription::apply()
{
  debug(DEBUG_IMPP, "UnSubscription::apply", "entered\n"); 
  
  DataManager *dm = DataManager::getInstance();
  PresentityDS* pds = dm->getPresentityDS(presentity);
  pds->remove(presentity);
  int ret = dm->removePresentity(presentity);
  //pds->remove(get_from_userdomain());      
  if(ret == -1){
    error("UnSubscription::apply()",
	  "Can't remove the presentity %s\n", presentity.c_str());
  } else {
    debug(DEBUG_IMPP, "UnSubscription::apply", "Successfully removed presentity: %s\n", 
	  presentity.c_str()); 
  }

  debug(DEBUG_IMPP, "UnSubscription::apply", "Done\n");
  return ret;
}

